package com.lightinit.hsdatashow.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StWaterRiverWaterLevelExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public StWaterRiverWaterLevelExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRiverIdIsNull() {
            addCriterion("river_id is null");
            return (Criteria) this;
        }

        public Criteria andRiverIdIsNotNull() {
            addCriterion("river_id is not null");
            return (Criteria) this;
        }

        public Criteria andRiverIdEqualTo(Long value) {
            addCriterion("river_id =", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdNotEqualTo(Long value) {
            addCriterion("river_id <>", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdGreaterThan(Long value) {
            addCriterion("river_id >", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdGreaterThanOrEqualTo(Long value) {
            addCriterion("river_id >=", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdLessThan(Long value) {
            addCriterion("river_id <", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdLessThanOrEqualTo(Long value) {
            addCriterion("river_id <=", value, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdIn(List<Long> values) {
            addCriterion("river_id in", values, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdNotIn(List<Long> values) {
            addCriterion("river_id not in", values, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdBetween(Long value1, Long value2) {
            addCriterion("river_id between", value1, value2, "riverId");
            return (Criteria) this;
        }

        public Criteria andRiverIdNotBetween(Long value1, Long value2) {
            addCriterion("river_id not between", value1, value2, "riverId");
            return (Criteria) this;
        }

        public Criteria andWaterLevelIsNull() {
            addCriterion("water_level is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelIsNotNull() {
            addCriterion("water_level is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelEqualTo(BigDecimal value) {
            addCriterion("water_level =", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNotEqualTo(BigDecimal value) {
            addCriterion("water_level <>", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelGreaterThan(BigDecimal value) {
            addCriterion("water_level >", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level >=", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelLessThan(BigDecimal value) {
            addCriterion("water_level <", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level <=", value, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelIn(List<BigDecimal> values) {
            addCriterion("water_level in", values, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNotIn(List<BigDecimal> values) {
            addCriterion("water_level not in", values, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level between", value1, value2, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level not between", value1, value2, "waterLevel");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeIsNull() {
            addCriterion("capture_time is null");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeIsNotNull() {
            addCriterion("capture_time is not null");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeEqualTo(Date value) {
            addCriterion("capture_time =", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeNotEqualTo(Date value) {
            addCriterion("capture_time <>", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeGreaterThan(Date value) {
            addCriterion("capture_time >", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("capture_time >=", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeLessThan(Date value) {
            addCriterion("capture_time <", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeLessThanOrEqualTo(Date value) {
            addCriterion("capture_time <=", value, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeIn(List<Date> values) {
            addCriterion("capture_time in", values, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeNotIn(List<Date> values) {
            addCriterion("capture_time not in", values, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeBetween(Date value1, Date value2) {
            addCriterion("capture_time between", value1, value2, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureTimeNotBetween(Date value1, Date value2) {
            addCriterion("capture_time not between", value1, value2, "captureTime");
            return (Criteria) this;
        }

        public Criteria andCaptureYearIsNull() {
            addCriterion("capture_year is null");
            return (Criteria) this;
        }

        public Criteria andCaptureYearIsNotNull() {
            addCriterion("capture_year is not null");
            return (Criteria) this;
        }

        public Criteria andCaptureYearEqualTo(Integer value) {
            addCriterion("capture_year =", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearNotEqualTo(Integer value) {
            addCriterion("capture_year <>", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearGreaterThan(Integer value) {
            addCriterion("capture_year >", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("capture_year >=", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearLessThan(Integer value) {
            addCriterion("capture_year <", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearLessThanOrEqualTo(Integer value) {
            addCriterion("capture_year <=", value, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearIn(List<Integer> values) {
            addCriterion("capture_year in", values, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearNotIn(List<Integer> values) {
            addCriterion("capture_year not in", values, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearBetween(Integer value1, Integer value2) {
            addCriterion("capture_year between", value1, value2, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureYearNotBetween(Integer value1, Integer value2) {
            addCriterion("capture_year not between", value1, value2, "captureYear");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthIsNull() {
            addCriterion("capture_month is null");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthIsNotNull() {
            addCriterion("capture_month is not null");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthEqualTo(Integer value) {
            addCriterion("capture_month =", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthNotEqualTo(Integer value) {
            addCriterion("capture_month <>", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthGreaterThan(Integer value) {
            addCriterion("capture_month >", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthGreaterThanOrEqualTo(Integer value) {
            addCriterion("capture_month >=", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthLessThan(Integer value) {
            addCriterion("capture_month <", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthLessThanOrEqualTo(Integer value) {
            addCriterion("capture_month <=", value, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthIn(List<Integer> values) {
            addCriterion("capture_month in", values, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthNotIn(List<Integer> values) {
            addCriterion("capture_month not in", values, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthBetween(Integer value1, Integer value2) {
            addCriterion("capture_month between", value1, value2, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureMonthNotBetween(Integer value1, Integer value2) {
            addCriterion("capture_month not between", value1, value2, "captureMonth");
            return (Criteria) this;
        }

        public Criteria andCaptureDayIsNull() {
            addCriterion("capture_day is null");
            return (Criteria) this;
        }

        public Criteria andCaptureDayIsNotNull() {
            addCriterion("capture_day is not null");
            return (Criteria) this;
        }

        public Criteria andCaptureDayEqualTo(Integer value) {
            addCriterion("capture_day =", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayNotEqualTo(Integer value) {
            addCriterion("capture_day <>", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayGreaterThan(Integer value) {
            addCriterion("capture_day >", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayGreaterThanOrEqualTo(Integer value) {
            addCriterion("capture_day >=", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayLessThan(Integer value) {
            addCriterion("capture_day <", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayLessThanOrEqualTo(Integer value) {
            addCriterion("capture_day <=", value, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayIn(List<Integer> values) {
            addCriterion("capture_day in", values, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayNotIn(List<Integer> values) {
            addCriterion("capture_day not in", values, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayBetween(Integer value1, Integer value2) {
            addCriterion("capture_day between", value1, value2, "captureDay");
            return (Criteria) this;
        }

        public Criteria andCaptureDayNotBetween(Integer value1, Integer value2) {
            addCriterion("capture_day not between", value1, value2, "captureDay");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(String value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(String value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(String value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(String value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(String value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(String value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLike(String value) {
            addCriterion("deleted_by like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotLike(String value) {
            addCriterion("deleted_by not like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<String> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<String> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(String value1, String value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(String value1, String value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}